	section crap,code_c		; Use Chip Memory
	opt	c-,o+			; No Case Sensitivity, Optimize on

	move.l	4.w,a6			; Get Execbase
	jsr	-132(a6)		; Turn off Muli-tasking (Forbid)
	lea	gfxlib,a1		
	moveq	#0,d0
	move.l	4.w,a6
	jsr	-$228(a6)		; Open graphics library
	tst	d0
	beq	error
	move.l	d0,gfxbse
	move.l	#screen,d0		; Store Screen address in Copper list
	move.w	d0,pl0l
	swap	d0
	move.w	d0,pl0h
	move.l	#screen3,d0
	move.w	d0,pl1l
	swap	d0
	move.w	d0,pl1h
	move.l	#screen5,d0
	move.w	d0,pl2l
	swap	d0
	move.w	d0,pl2h
	move.l	#sprite0,d0
	move.w	d0,sp0l
	swap	d0
	move.w	d0,sp0h
	move.l	gfxbse,a6		; Set up copper list
	add.l	#$32,a6
	move.w	#$87ff,$dff096
	move.l	(a6),oldcpr		; Store workbench copper list
	move.l	#newcpr,(a6)		; Use our copper list
	move.w	#$0020,$dff096
	move.w	#$8010,$dff09a		; Enable level 3 interrupt
	move.l	$6c.w,old		; Store old level 3 interrupt
	move.l	#new,$6c.w		; Use our interrupt
	bset	#1,$bfe001
	move.w	#0,$dff042
	jsr	init_music

	move.l	#logo,$dff050
	move.l	#screen3+40,$dff054
	move.l	#$ffffffff,$dff044
	move.w	#0,$dff066
	move.w	#0,$dff064
	move.w	#$09f0,$dff040
	move.w	#%111001010100,$dff058

	move.l	#logo+(40*58),$dff050
	move.l	#screen5+40,$dff054
	move.l	#$ffffffff,$dff044
	move.w	#0,$dff066
	move.w	#0,$dff064
	move.w	#$09f0,$dff040
	move.w	#%111000010100,$dff058

wait:	btst	#6,$bfe001		; Test for left mouse button
	bne.s	wait			; Wait if not pressed
	jsr	end_music
	bclr	#1,$bfe001
	move.l	old,$6c.w		; Else return to workbench
	move.l	#$10,$dff09a		; Disable copper interrupt
	move.l	gfxbse,a6		; Copper list
	add.l	#$32,a6
	move.w	#$8020,$dff096
	move.l	oldcpr,(a6)
;	move.w	#$8080,$dff096
	move.l	gfxbse,a1		; Close graphics library
	move.l	$4.w,a6
	jsr	-$19e(a6)
	move.l	$4.w,a6			; Execbase
	jsr	-138(a6)		; Permit - Restart multi-tasking
error:	moveq	#0,d0			; Exit routine
	rts

pause:	dc.w	0
text1:	dc.b	"         OH NOOOOOOO!!!!!    @             YEP, YOU GUESSED IT!!!!!               "
	DC.B	"   MAGNETIC FIELDS     @  "
	DC.B	"ONCE A-FUCKING-GAIN HIT YOUR TOTALLY KNACKERED SCREENS WITH.....             "
	DC.B	"   WELL ",39,"ARD WARES    @  "
	dc.b	"                 "
	DC.B	"THE"
	DC.B	" CREDITS FOR THIS SINE INTRO (SINE INTRO V4)"
	DC.B	" GO TO.....                "
	DC.B	"       SPOOK - CODING     @"
	DC.B	"      MAYHEM - CHARSET    @"
	DC.B	"         NO.5 - LOGO      @"
	DC.B	"      DEXTROUS - MUSIC    @ "
	DCb.B	60,"-"
	dc.b	"                 MEMBERS OF MAGNETIC FIELDS ARE (A-Z).....                "
	DC.B	"< ANZ <         @      "
	DC.B	"< BACCHUS <       @      "
 	DC.B	"< COSY <        @      "
	DC.B	"< DEXTROUS <      @      "
	DC.B	"< HIT <         @      "
	DC.B	"< FRAP <        @      "
	DC.B	"< FRENZY <       @      "
	DC.B	"< NO.5 <        @      "
	DC.B	"< OPAL <        @      "
	DC.B	"< SISTERARV <      @      "
	DC.B	"< SLAT <        @      "
	DC.B	"< SPIKE <        @      "
	DC.B	"< SPOOK <        @      "
	DC.B	"< Z80 <         @      "
	DC.B	"                                "
	DC.B	"HERE ARE THE GREETS (TO KEEP EVERYONE HAPPY!).......                        "
	INCLUDE	"GREETS.TXT"
	dc.b	"                      "
	dc.b	"A FEW SPECIAL GREETS TO ALL MY (SPOOK) CONTACTS"
	DC.B	"......    WADZ/ACIDFORCE (SOZ 4 DELAY!!!) - "
	DC.B	"ENIGMA/SLIPSTREAM (SOZ 4 DELAY!!! (DO I GET A SPECIAL GREET NOW?))"
	DC.B	" - SHADOW/UNTOUCHABLES (ERMMM... I",39,"LL SEND SOON - HONEST!!!) - "
	DC.B	"TURBO SLUG/THR (DON",39,"T LAUGH AT MY CODE!!! - SEND YOURS SOON!!!) - "
	DC.B	"THAT",39,"S IT!!!            "
	DC.B	"NOW FUCK OFF AND KILL A B.T. EMPLOYEE!!!!!!       "
	DC.B	"SEE YA NEXT DEMO/INTRO/COCK-UP!!    SPOOK!     "
	DC.B	"                        ",0

	even

new:	movem.l	d0-d7/a0-a6,-(sp)	; Save all registers
	and.w	#$10,$dff01e		; Check if it is copper interrupt
	beq	out			; If not, skip this code
	move.w	#$10,$dff09c

;	**********************************************************
;	***          This is where the code goes!!!!           ***
;	**********************************************************

	movem.l	d0-d7/a0-a6,-(sp)
	jsr	play_music
	movem.l	(sp)+,d0-d7/a0-a6

	jsr	switchscreen

	move.l	current,d0		; Store Screen address in Copper list
	move.w	d0,pl0l
	swap	d0
	move.w	d0,pl0h
;	swap	d0
;	add.l	#40,d0
;	move.w	d0,pl1l
;	swap	d0
;	move.w	d0,pl1h

	move.l	ripos,a0
	lea	water+6,a1
	move.w	#64,d0
riplit:	move.w	(a0),(a1)
	addq.l	#4,a1
	move.w	(a0)+,(a1)
	add.l	#24,a1
	cmp.w	#999,(a0)
	bne.s	loop
	lea	ripple,a0
loop:	dbf	d0,riplit
	move.l	ripos,a0
	addq.l	#2,a0
	move.w	(a0),d0
	cmp.w	#999,d0
	bne.s	pb
	lea	ripple,a0
pb:	move.l	a0,ripos

	move.w	pause,d0
	tst.w	d0
	beq.s	goon
	subq.w	#1,d0
	move.w	d0,pause
	move.w	#0,shift
	bra.w	noscroll

goon:	move.l	#scroll+2,$dff050
	move.l	#scroll,$dff054
	move.l	#$ffffffff,$dff044
	move.w	#0,$dff066
	move.w	#0,$dff064
	move.w	shift,d0
	tst.w	shift
	bne.s	subit
	move.w	#%1110000000000000,d0
	bra.s	putit
subit:	sub.w	#%0010000000000000,d0
putit:	move.w	d0,shift
	move.w	#$e9f0,$dff040
	move.w	#%01101011000,$dff058

	move.l	tpoi1,a0
	move.b	(a0)+,d0
	cmp.b	#"@",d0
	bne.s	test
	move.w	#200,pause
	move.l	a0,tpoi1
	bra.s	noscroll

test:	move.w	shift,d0
	tst.w	d0
	bne.s	noscroll

noshit:	move.l	tpoi1,a0
	move.l	#0,d0
	move.b	(a0)+,d0
	tst.b	d0
	bne.s	find
	lea	text1,a0
	move.b	(a0),d0
find:	move.l	a0,tpoi1
	sub.b	#$20,d0
	lea	chars,a0
loopy:	cmp.b	#19,d0
	ble.s	smch
	sub.b	#20,d0
	add.l	#40*16,a0
	bra.s	loopy
smch	add.l	d0,a0
	add.l	d0,a0
	move.l	a0,char1

noscroll:
	move.l	char1,a0
	move.l	a0,$dff050
	move.l	#scroll,$dff054
	move.l	#$ffffffff,$dff044
	move.w	#46,$dff066
	move.w	#38,$dff064
	move.w	#$09f0,d1
	move.w	shift,d0
	add.w	d1,d0
	move.w	d0,$dff040
	move.w	#%01110000001,$dff058

;	move.w	#12,d0
;looop:	move.w	(a0),(a1)
;	add.l	#48,a1
;	add.l	#40,a0
;	dbf	d0,looop

	moveq.w	#4,d4
	move.w	#19,d3
	move.w	#38,$dff066		; Dest Modulo
	move.w	#46,$dff064		; Source Modulo
	move.w	#38,$dff062		; Source Modulo

	move.l	wavemove,a3
	move.l	wavemove2,a4

;	***** Lob Each pixel to screen at differing heights *****

bull:	move.l	dest,a2	; Destination
	add.l	d4,a2
	sub.l	#40*49,a2
	move.l	a2,storage

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez
	lea	sinew,a3
jeeez:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez
	lea	sinew2,a4
jeez:
	move.l	source,a0	; Source
	add.l	d4,a0
	sub.l	#(48*49)-2,a0

	move.l	a0,$dff050
	move.l	a2,$dff054
	move.l	#$80008000,$dff044
	move.w	#%0000100111110000,$dff040
	move.w	#%1101111000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

	add.l	#48*49,a0
	move.l	dest,a2	; Destination
	add.l	d4,a2
	move.l	a2,storage

;	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez2
	lea	sinew,a3
jeeez2:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez2
	lea	sinew2,a4
jeez2:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$40004000,$dff044
	move.w	#%0000110111111100,$dff040
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez3
	lea	sinew,a3
jeeez3:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez3
	lea	sinew2,a4
jeez3:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$20002000,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez4
	lea	sinew,a3
jeeez4:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez4
	lea	sinew2,a4
jeez4:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$10001000,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez5
	lea	sinew,a3
jeeez5:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez5
	lea	sinew2,a4
jeez5:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$08000800,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez6
	lea	sinew,a3
jeeez6:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez6
	lea	sinew2,a4
jeez6:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$04000400,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez7
	lea	sinew,a3
jeeez7:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez7
	lea	sinew2,a4
jeez7:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$02000200,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez8
	lea	sinew,a3
jeeez8:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez8
	lea	sinew2,a4
jeez8:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$01000100,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez9
	lea	sinew,a3
jeeez9:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez9
	lea	sinew2,a4
jeez9:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$00800080,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez10
	lea	sinew,a3
jeeez10:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez10
	lea	sinew2,a4
jeez10:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$00400040,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez11
	lea	sinew,a3
jeeez11:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez11
	lea	sinew2,a4
jeez11:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$00200020,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez12
	lea	sinew,a3
jeeez12:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez12
	lea	sinew2,a4
jeez12:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$00100010,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez13
	lea	sinew,a3
jeeez13:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez13
	lea	sinew2,a4
jeez13:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$00080008,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez14
	lea	sinew,a3
jeeez14:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez14
	lea	sinew2,a4
jeez14:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$00040004,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez15
	lea	sinew,a3
jeeez15:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez15
	lea	sinew2,a4
jeez15:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$00020002,$dff044
	move.w	#%01101000001,$dff058

;	***** Lob Next Pixel to screen!!! *****

;	move.l	dest,a2	; Destination
;	add.l	d4,a2

	move.l	storage,a2
	move.w	(a3)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a3)
	bne.s	jeeez16
	lea	sinew,a3
jeeez16:	move.w	(a4)+,d5
	add.w	d5,a2
	cmp.w	#9999,(a4)
	bne.s	jeez16
	lea	sinew2,a4
jeez16:
	move.l	a0,$dff050
	move.l	a2,$dff04c
	move.l	a2,$dff054
	move.l	#$00010001,$dff044
	move.w	#%01101000001,$dff058

	addq.w	#2,d4

	dbf	d3,bull

	move.l	wavemove,a0
	subq.l	#6,a0
	cmp.w	#9999,(a0)
	bne.s	ok
	lea	sinend,a0
ok:	move.l	a0,wavemove

	move.l	wavemove2,a0
	addq.l	#2,a0
	cmp.w	#9999,(a0)
	bne.s	ok2
	lea	sinew2,a0
ok2:	move.l	a0,wavemove2

	move.b	vs4,d0
	tst.b	d0
	beq.s	nobar1
	move.l	#0,h4
	move.w	#29,i4
nobar1:
	move.b	vs3,d0
	tst.b	d0
	beq.s	nobar2
	move.l	#0,h3
	move.w	#29,i3
nobar2:
	move.b	vs2,d0
	tst.b	d0
	beq.s	nobar3
	move.l	#0,h2
	move.w	#29,i2
nobar3:
	move.b	vs1,d0
	tst.b	d0
	beq.s	nobar4
	move.l	#0,h1
	move.w	#29,i1
nobar4:
	move.l	#screen3+(40*137)-6,a0
	move.l	h4,d0
	add.l	d0,a0
	move.w	i4,d0
	move.w	#$0000,(a0)
	add.l	#80,a0
wanker:	move.w	#$ffff,(a0)
	add.l	#80,a0
	dbf	d0,wanker

	move.l	#screen3+(40*137)-16,a0
	move.l	h3,d0
	add.l	d0,a0
	move.w	i3,d0
	move.w	#$0000,(a0)
	add.l	#80,a0
wanker2:move.w	#$ffff,(a0)
	add.l	#80,a0
	dbf	d0,wanker2

	move.l	#screen3+(40*137)-26,a0
	move.l	h2,d0
	add.l	d0,a0
	move.w	i2,d0
	move.w	#$0000,(a0)
	add.l	#80,a0
wanker3:move.w	#$ffff,(a0)
	add.l	#80,a0
	dbf	d0,wanker3

	move.l	#screen3+(40*137)-36,a0
	move.l	h1,d0
	add.l	d0,a0
	move.w	i1,d0
	move.w	#$0000,(a0)
	add.l	#80,a0
wanker4:move.w	#$ffff,(a0)
	add.l	#80,a0
	dbf	d0,wanker4

	move.l	h4,d0
	cmp.l	#29*80,d0
	bge.s	not1
	add.l	#80,d0
	move.l	d0,h4
	move.w	i4,d0
	subq.w	#1,d0
	move.w	d0,i4
not1:
	move.l	h3,d0
	cmp.l	#29*80,d0
	bge.s	not2
	add.l	#80,d0
	move.l	d0,h3
	move.w	i3,d0
	subq.w	#1,d0
	move.w	d0,i3
not2:
	move.l	h2,d0
	cmp.l	#29*80,d0
	bge.s	not3
	add.l	#80,d0
	move.l	d0,h2
	move.w	i2,d0
	subq.w	#1,d0
	move.w	d0,i2
not3:
	move.l	h1,d0
	cmp.l	#29*80,d0
	bge.s	not4
	add.l	#80,d0
	move.l	d0,h1
	move.w	i1,d0
	subq.w	#1,d0
	move.w	d0,i1
not4:

out:	movem.l	(sp)+,d0-d7/a0-a6	; Restore registers

	dc.w	$4ef9			; JSR instruction

old:	dc.l	0
oldcpr:	dc.l	0			; Workbench copper list

current	dc.l	screen
storage	dc.l	0
source:	dc.l	scroll
dest:	dc.l	screen+(2*40)-4
dest1:	dc.l	screen+(2*40)-4
dest2:	dc.l	screen2+(2*40)-4
tpoi1:	dc.l	text1

char1:	dc.l	chars

h1:	dc.l	0
h2:	dc.l	0
h3:	dc.l	0
h4:	dc.l	0
i1:	dc.w	29
i2:	dc.w	29
i3:	dc.w	29
i4:	dc.w	29

apoi:	dc.l	0
;pos1:	dc.l	sine2
;pos2:	dc.l	sine
posit:	dc.w	0
shift:	dc.w	%1110000000000000
shift2:	dc.w	%1110000000000000
v1dat:	dc.w	0
v2dat:	dc.w	0
v3dat:	dc.w	0
v4dat:	dc.w	0

newcpr:	dc.w	$100,%0011001000000000,$102,0,$108,0,$10a,0
	dc.w	$92,$38,$94,$d0,$8e,$2c81,$90,$38c1,$e0
pl0h:	dc.w	0,$e2
pl0l:	dc.w	0,$e4
pl1h:	dc.w	0,$e6
pl1l:	dc.w	0,$e8
pl2h:	dc.w	0,$ea
pl2l:	dc.w	0,$120
SP0H DC.W 0,$122
SP0L DC.W 0
	dc.w	$180,$000
	dc.w	$182,$000
	dc.w	$184,$fff
	dc.w	$186,$fff
	dc.w	$188,$88f
	dc.w	$18a,$88f
	dc.w	$18c,$000
	dc.w	$18e,$000
	dc.w	$9c,$8010		; Call copper interrupt

	dc.w	$0001,$fffe,$180,$fff
	dc.w	$2801,$fffe,$180,$ffe
	dc.w	$3001,$fffe,$180,$ffd
	dc.w	$3801,$fffe,$180,$ffc
	dc.w	$4001,$fffe,$180,$ffb
	dc.w	$4801,$fffe,$180,$ffa
	dc.w	$5001,$fffe,$180,$ff9
	dc.w	$5801,$fffe,$180,$ff8
	dc.w	$6001,$fffe,$180,$ff7
	dc.w	$6801,$fffe,$180,$ff6
	dc.w	$7001,$fffe,$180,$ff5
	dc.w	$7801,$fffe,$180,$ff4
	dc.w	$8001,$fffe,$180,$ff3
	dc.w	$8801,$fffe,$180,$ff2
	dc.w	$9001,$fffe,$180,$ff1
	dc.w	$9801,$fffe,$180,$ff0
	dc.w	$a001,$fffe,$180,$fe2
	dc.w	$a401,$fffe,$180,$fe0
	dc.w	$a801,$fffe,$180,$fd2
	dc.w	$ac01,$fffe,$180,$fd0
	dc.w	$b001,$fffe,$180,$fc2
	dc.w	$b401,$fffe,$180,$fc0
	dc.w	$b801,$fffe,$180,$fb2
	dc.w	$bc01,$fffe,$180,$fb0
	dc.w	$c001,$fffe,$180,$fa2
	dc.w	$c401,$fffe,$180,$fa0
	dc.w	$c801,$fffe,$180,$f92
	dc.w	$cc01,$fffe,$180,$f90
	dc.w	$d001,$fffe,$180,$f82
	dc.w	$d401,$fffe,$180,$f80
	dc.w	$d801,$fffe,$180,$f72
	dc.w	$dc01,$fffe,$180,$f70
	dc.w	$e001,$fffe,$180,$f62
	dc.w	$e401,$fffe,$180,$f60
	dc.w	$e801,$fffe,$180,$f52
	dc.w	$ec01,$fffe,$180,$f50

	dc.w	$188,$66c
	dc.w	$18a,$66c
	dc.w	$18c,$22a
	dc.w	$18e,$22a

water:	dc.w	$ef01,$fffe,$108,-120,$10a,-120,$180,$0004,$184,$044a,$186,$0226,$182,$0007
	dc.w	$f001,$fffe,$108,-120,$10a,-120,$180,$0014,$184,$044a,$186,$0226,$182,$0007
	dc.w	$f101,$fffe,$108,-120,$10a,-120,$180,$0104,$184,$044a,$186,$0226,$182,$0007
	dc.w	$f201,$fffe,$108,-120,$10a,-120,$180,$0114,$184,$044a,$186,$0226,$182,$0007
	dc.w	$f301,$fffe,$108,-120,$10a,-120,$180,$0005,$184,$044a,$186,$0226,$182,$0008
	dc.w	$f401,$fffe,$108,-120,$10a,-120,$180,$0015,$184,$055b,$186,$0226,$182,$0008
	dc.w	$f501,$fffe,$108,-120,$10a,-120,$180,$0105,$184,$055b,$186,$0226,$182,$0008
	dc.w	$f601,$fffe,$108,-120,$10a,-120,$180,$0115,$184,$055b,$186,$0337,$182,$0008
	dc.w	$f701,$fffe,$108,-120,$10a,-120,$180,$0006,$184,$055b,$186,$0337,$182,$0118
	dc.w	$f801,$fffe,$108,-120,$10a,-120,$180,$0016,$184,$055b,$186,$0337,$182,$0118
	dc.w	$f901,$fffe,$108,-120,$10a,-120,$180,$0106,$184,$066b,$186,$0337,$182,$0118
	dc.w	$fa01,$fffe,$108,-120,$10a,-120,$180,$0116,$184,$066b,$186,$0337,$182,$0118
	dc.w	$fb01,$fffe,$108,-120,$10a,-120,$180,$0007,$184,$066b,$186,$0337,$182,$0119
	dc.w	$fc01,$fffe,$108,-120,$10a,-120,$180,$0017,$184,$066b,$186,$0448,$182,$0119
	dc.w	$fd01,$fffe,$108,-120,$10a,-120,$180,$0107,$184,$066b,$186,$0448,$182,$0119
	dc.w	$fe01,$fffe,$108,-120,$10a,-120,$180,$0117,$184,$077c,$186,$0448,$182,$0119
	dc.w	$ff01,$fffe,$108,-120,$10a,-120,$180,$0008,$184,$077c,$186,$0448,$182,$0229
	dc.w	$ffe1,$fffe,$108,-120,$10a,-120,$180,$0018,$184,$077c,$186,$0448,$182,$0229
	dc.w	$0101,$fffe,$108,-120,$10a,-120,$180,$0108,$184,$077c,$186,$0448,$182,$0229
	dc.w	$0201,$fffe,$108,-120,$10a,-120,$180,$0118,$184,$077c,$186,$0559,$182,$0229
	dc.w	$0301,$fffe,$108,-120,$10a,-120,$180,$0009,$184,$088c,$186,$0559,$182,$022a
	dc.w	$0401,$fffe,$108,-120,$10a,-120,$180,$0019,$184,$088c,$186,$0559,$182,$022a
	dc.w	$0501,$fffe,$108,-120,$10a,-120,$180,$0109,$184,$088c,$186,$0559,$182,$022a
	dc.w	$0601,$fffe,$108,-120,$10a,-120,$180,$0119,$184,$088c,$186,$0559,$182,$022a
	dc.w	$0701,$fffe,$108,-120,$10a,-120,$180,$000a,$184,$088c,$186,$0559,$182,$033a
	dc.w	$0801,$fffe,$108,-120,$10a,-120,$180,$001a,$184,$099d,$186,$066a,$182,$033a
	dc.w	$0901,$fffe,$108,-120,$10a,-120,$180,$010a,$184,$099d,$186,$066a,$182,$033a
	dc.w	$0a01,$fffe,$108,-120,$10a,-120,$180,$011a,$184,$099d,$186,$066a,$182,$033a
	dc.w	$0b01,$fffe,$108,-120,$10a,-120,$180,$000b,$184,$099d,$186,$066a,$182,$033b
	dc.w	$0c01,$fffe,$108,-120,$10a,-120,$180,$001b,$184,$099d,$186,$066a,$182,$033b
	dc.w	$0d01,$fffe,$108,-120,$10a,-120,$180,$010b,$184,$0aad,$186,$066a,$182,$033b
	dc.w	$0e01,$fffe,$108,-120,$10a,-120,$180,$011b,$184,$0aad,$186,$077b,$182,$033b
	dc.w	$0f01,$fffe,$108,-120,$10a,-120,$180,$000c,$184,$0aad,$186,$077b,$182,$044b
	dc.w	$1001,$fffe,$108,-120,$10a,-120,$180,$001c,$184,$0aad,$186,$077b,$182,$044b
	dc.w	$1101,$fffe,$108,-120,$10a,-120,$180,$010c,$184,$0aad,$186,$077b,$182,$044b
	dc.w	$1201,$fffe,$108,-120,$10a,-120,$180,$011c,$184,$0bbe,$186,$077b,$182,$044b
	dc.w	$1301,$fffe,$108,-120,$10a,-120,$180,$000d,$184,$0bbe,$186,$077b,$182,$044c
	dc.w	$1401,$fffe,$108,-120,$10a,-120,$180,$001d,$184,$0bbe,$186,$088c,$182,$044c
	dc.w	$1501,$fffe,$108,-120,$10a,-120,$180,$010d,$184,$0bbe,$186,$088c,$182,$044c
	dc.w	$1601,$fffe,$108,-120,$10a,-120,$180,$011d,$184,$0bbe,$186,$088c,$182,$044c
	dc.w	$1701,$fffe,$108,-120,$10a,-120,$180,$000e,$184,$0cce,$186,$088c,$182,$055c
	dc.w	$1801,$fffe,$108,-120,$10a,-120,$180,$001e,$184,$0cce,$186,$088c,$182,$055c
	dc.w	$1901,$fffe,$108,-120,$10a,-120,$180,$010e,$184,$0cce,$186,$088c,$182,$055c
	dc.w	$1a01,$fffe,$108,-120,$10a,-120,$180,$011e,$184,$0cce,$186,$099d,$182,$055c
	dc.w	$1b01,$fffe,$108,-120,$10a,-120,$180,$000f,$184,$0cce,$186,$099d,$182,$055d
	dc.w	$1c01,$fffe,$108,-120,$10a,-120,$180,$001f,$184,$0ddf,$186,$099d,$182,$055d
	dc.w	$1d01,$fffe,$108,-120,$10a,-120,$180,$010f,$184,$0ddf,$186,$099d,$182,$055d
	dc.w	$1e01,$fffe,$108,-120,$10a,-120,$180,$011f,$184,$0ddf,$186,$099d,$182,$055d
	dc.w	$1f01,$fffe,$108,-120,$10a,-120,$180,$021f,$184,$0ddf,$186,$099d,$182,$066d
	dc.w	$2001,$fffe,$108,-120,$10a,-120,$180,$021f,$184,$0ddf,$186,$0aae,$182,$066d
	dc.w	$2101,$fffe,$108,-120,$10a,-120,$180,$022f,$184,$0eef,$186,$0aae,$182,$066d
	dc.w	$2201,$fffe,$108,-120,$10a,-120,$180,$022f,$184,$0eef,$186,$0aae,$182,$066d
	dc.w	$2301,$fffe,$108,-120,$10a,-120,$180,$032f,$184,$0eef,$186,$0aae,$182,$066e
	dc.w	$2401,$fffe,$108,-120,$10a,-120,$180,$032f,$184,$0eef,$186,$0aae,$182,$066e
	dc.w	$2501,$fffe,$108,-120,$10a,-120,$180,$033f,$184,$0eef,$186,$0aae,$182,$066e
	dc.w	$2601,$fffe,$108,-120,$10a,-120,$180,$033f,$184,$0fff,$186,$0bbf,$182,$066e
	dc.w	$2701,$fffe,$108,-120,$10a,-120,$180,$043f,$184,$0fff,$186,$0bbf,$182,$077e
	dc.w	$2801,$fffe,$108,-120,$10a,-120,$180,$043f,$184,$0fff,$186,$0bbf,$182,$077e
	dc.w	$2901,$fffe,$108,-120,$10a,-120,$180,$044f,$184,$0fff,$186,$0bbf,$182,$077e
	dc.w	$2a01,$fffe,$108,-120,$10a,-120,$180,$044f,$184,$0fff,$186,$0bbf,$182,$077e
	dc.w	$2b01,$fffe,$108,-120,$10a,-120,$180,$054f,$184,$0fff,$186,$0bbf,$182,$077f
	dc.w	$2c01,$fffe,$108,-120,$10a,-120,$180,$054f,$184,$0fff,$186,$0ccf,$182,$077f
	dc.w	$2d01,$fffe,$108,-120,$10a,-120,$180,$055f,$184,$0fff,$186,$0ccf,$182,$077f
	dc.w	$2e01,$fffe,$108,-120,$10a,-120,$180,$055f,$184,$0fff,$186,$0ccf,$182,$077f
	dc.w	$2f01,$fffe,$108,-120,$10a,-120,$180,$065f,$184,$0fff,$186,$0ccf,$182,$088f
	dc.w	$ffff,$fffe		; End copper

gfxlib:	dc.b	"graphics.library",0
	even
gfxbse:	dc.l	0

		dcb.b	100*40,0
screen:		dcb.b	40*310,0
screen2:	dcb.b	40*310,0
screen3:	dcb.b	40*240,0
screen4:	dcb.b	40*80,0
screen5:	dcb.b	40*240,0

ripple:	dc.w	-080,-080,-080,-080,-080,-080,-080,-080,-080,-080
	dc.w	-120,-080,-080,-080,-080,-080,-120,-080,-080,-080
	dc.w	-080,-120,-080,-080,-080,-120,-080,-080,-120,-080
	dc.w	-120,-120,-080,-120,-120,-120,-080,-120,-120,-120
	dc.w	-120,-080,-120,-120,-120,-120,-120,-080,-120,-120
	dc.w	-120,-120,-120,-120,-120,-120,-120,-120,-160,-120
	dc.w	-120,-120,-120,-120,-160,-120,-120,-120,-120,-160
	dc.w	-120,-120,-120,-160,-120,-120,-160,-120,-160,-160
	dc.w	-120,-160,-160,-160,-120,-160,-160,-160,-160,-120
	dc.w	-160,-160,-160,-160,-160,-120,-160,-160,-160,-160
	dc.w	-160,-160,-160,-160,-160,-160,-120,-160,-160,-160
	dc.w	-160,-160,-120,-160,-160,-160,-160,-120,-160,-160
	dc.w	-160,-120,-160,-160,-120,-160,-120,-120,-160,-120
	dc.w	-120,-120,-160,-120,-120,-120,-120,-160,-120,-120
	dc.w	-120,-120,-120,-160,-120,-120,-120,-120,-120,-120
	dc.w	-120,-120,-120,-120,-080,-120,-120,-120,-120,-120
	dc.w	-080,-120,-120,-120,-120,-080,-120,-120,-120,-080
	dc.w	-120,-120,-080,-120,-080,-080,-120,-080,-080,-080
	dc.w	-120,-080,-080,-080,-080,-120,-080,-080,-080,-080
	dc.w	-080,-120,999

ripos:	dc.l	ripple

chars:	incbin	"charset"
	dcb.w	52*100,0
scroll:	dcb.w	52*150,0

dir:	dc.w	0

switchscreen:
	move.l	current,a0
	cmp.l	#screen,a0
	bne.s	sc2
	move.l	#screen2,a0
	move.l	a0,current
	move.l	dest2,a0
	move.l	a0,dest
	rts

sc2:	move.l	#screen,a0
	move.l	a0,current
	move.l	dest1,a0
	move.l	a0,dest
	rts

wavepos:
	dc.l	sinew
wavemove:
	dc.l	sinew
wavepos2:
	dc.l	sinew2
wavemove2:
	dc.l	sinew2

sprite0:
	dc.w	0,0,0,0,0,0

	dc.w	9999,9999,9999,9999,9999
sinew:
m=40
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   1*m
  DC.W   1*m
  DC.W   1*m
  DC.W   1*m
  DC.W   2*m
  DC.W   2*m
  DC.W   2*m
  DC.W   3*m
  DC.W   3*m
  DC.W   4*m
  DC.W   4*m
  DC.W   5*m
  DC.W   6*m
  DC.W   6*m
  DC.W   7*m
  DC.W   8*m
  DC.W   8*m
  DC.W   9*m
  DC.W   10*m
  DC.W   11*m
  DC.W   12*m
  DC.W   13*m
  DC.W   14*m
  DC.W   15*m
  DC.W   16*m
  DC.W   17*m
  DC.W   18*m
  DC.W   19*m
  DC.W   20*m
  DC.W   21*m
  DC.W   22*m
  DC.W   23*m
  DC.W   24*m
  DC.W   26*m
  DC.W   27*m
  DC.W   28*m
  DC.W   30*m
  DC.W   31*m
  DC.W   32*m
  DC.W   33*m
  DC.W   35*m
  DC.W   36*m
  DC.W   38*m
  DC.W   39*m
  DC.W   40*m
  DC.W   42*m
  DC.W   43*m
  DC.W   45*m
  DC.W   46*m
  DC.W   48*m
  DC.W   49*m
  DC.W   51*m
  DC.W   52*m
  DC.W   54*m
  DC.W   55*m
  DC.W   57*m
  DC.W   58*m
  DC.W   60*m
  DC.W   61*m
  DC.W   63*m
  DC.W   64*m
  DC.W   66*m
  DC.W   67*m
  DC.W   68*m
  DC.W   70*m
  DC.W   71*m
  DC.W   73*m
  DC.W   74*m
  DC.W   76*m
  DC.W   77*m
  DC.W   79*m
  DC.W   80*m
  DC.W   82*m
  DC.W   83*m
  DC.W   84*m
  DC.W   86*m
  DC.W   87*m
  DC.W   88*m
  DC.W   90*m
  DC.W   91*m
  DC.W   92*m
  DC.W   93*m
  DC.W   95*m
  DC.W   96*m
  DC.W   97*m
  DC.W   98*m
  DC.W   99*m
  DC.W   101*m
  DC.W   102*m
  DC.W   103*m
  DC.W   104*m
  DC.W   105*m
  DC.W   106*m
  DC.W   107*m
  DC.W   108*m
  DC.W   109*m
  DC.W   109*m
  DC.W   110*m
  DC.W   111*m
  DC.W   112*m
  DC.W   113*m
  DC.W   113*m
  DC.W   114*m
  DC.W   115*m
  DC.W   115*m
  DC.W   116*m
  DC.W   116*m
  DC.W   117*m
  DC.W   117*m
  DC.W   118*m
  DC.W   118*m
  DC.W   119*m
  DC.W   119*m
  DC.W   119*m
  DC.W   119*m
  DC.W   120*m
  DC.W   120*m
  DC.W   120*m
  DC.W   120*m
  DC.W   120*m
  DC.W   120*m
  DC.W   120*m
  DC.W   120*m
  DC.W   120*m
  DC.W   120*m
  DC.W   119*m
  DC.W   119*m
  DC.W   119*m
  DC.W   119*m
  DC.W   118*m
  DC.W   118*m
  DC.W   118*m
  DC.W   117*m
  DC.W   117*m
  DC.W   116*m
  DC.W   116*m
  DC.W   115*m
  DC.W   115*m
  DC.W   114*m
  DC.W   113*m
  DC.W   113*m
  DC.W   112*m
  DC.W   111*m
  DC.W   110*m
  DC.W   109*m
  DC.W   109*m
  DC.W   108*m
  DC.W   107*m
  DC.W   106*m
  DC.W   105*m
  DC.W   104*m
  DC.W   103*m
  DC.W   102*m
  DC.W   101*m
  DC.W   99*m
  DC.W   98*m
  DC.W   97*m
  DC.W   96*m
  DC.W   95*m
  DC.W   93*m
  DC.W   92*m
  DC.W   91*m
  DC.W   90*m
  DC.W   88*m
  DC.W   87*m
  DC.W   86*m
  DC.W   84*m
  DC.W   83*m
  DC.W   82*m
  DC.W   80*m
  DC.W   79*m
  DC.W   77*m
  DC.W   76*m
  DC.W   74*m
  DC.W   73*m
  DC.W   71*m
  DC.W   70*m
  DC.W   68*m
  DC.W   67*m
  DC.W   65*m
  DC.W   64*m
  DC.W   62*m
  DC.W   61*m
  DC.W   59*m
  DC.W   58*m
  DC.W   56*m
  DC.W   55*m
  DC.W   54*m
  DC.W   52*m
  DC.W   51*m
  DC.W   49*m
  DC.W   48*m
  DC.W   46*m
  DC.W   45*m
  DC.W   43*m
  DC.W   42*m
  DC.W   40*m
  DC.W   39*m
  DC.W   38*m
  DC.W   36*m
  DC.W   35*m
  DC.W   33*m
  DC.W   32*m
  DC.W   31*m
  DC.W   29*m
  DC.W   28*m
  DC.W   27*m
  DC.W   26*m
  DC.W   24*m
  DC.W   23*m
  DC.W   22*m
  DC.W   21*m
  DC.W   20*m
  DC.W   19*m
  DC.W   18*m
  DC.W   17*m
  DC.W   16*m
  DC.W   15*m
  DC.W   14*m
  DC.W   13*m
  DC.W   12*m
  DC.W   11*m
  DC.W   10*m
  DC.W   9*m
  DC.W   8*m
  DC.W   8*m
  DC.W   7*m
  DC.W   6*m
  DC.W   6*m
  DC.W   5*m
  DC.W   4*m
  DC.W   4*m
  DC.W   3*m
  DC.W   3*m
  DC.W   2*m
  DC.W   2*m
  DC.W   2*m
  DC.W   1*m
  DC.W   1*m
  DC.W   1*m
sinend:
  DC.W   1*m
	dc.w	9999,9999,9999,9999,9999,9999
sinew2:
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   0
  DC.W   1/2*m
  DC.W   1/2*m
  DC.W   2/2*m
  DC.W   3/2*m
  DC.W   3/2*m
  DC.W   4/2*m
  DC.W   5/2*m
  DC.W   7/2*m
  DC.W   8/2*m
  DC.W   9/2*m
  DC.W   11/2*m
  DC.W   12/2*m
  DC.W   14/2*m
  DC.W   16/2*m
  DC.W   18/2*m
  DC.W   20/2*m
  DC.W   22/2*m
  DC.W   24/2*m
  DC.W   26/2*m
  DC.W   28/2*m
  DC.W   31/2*m
  DC.W   33/2*m
  DC.W   35/2*m
  DC.W   38/2*m
  DC.W   40/2*m
  DC.W   43/2*m
  DC.W   46/2*m
  DC.W   48/2*m
  DC.W   51/2*m
  DC.W   54/2*m
  DC.W   56/2*m
  DC.W   59/2*m
  DC.W   62/2*m
  DC.W   64/2*m
  DC.W   67/2*m
  DC.W   70/2*m
  DC.W   72/2*m
  DC.W   75/2*m
  DC.W   78/2*m
  DC.W   80/2*m
  DC.W   83/2*m
  DC.W   85/2*m
  DC.W   88/2*m
  DC.W   90/2*m
  DC.W   92/2*m
  DC.W   94/2*m
  DC.W   97/2*m
  DC.W   99/2*m
  DC.W   101/2*m
  DC.W   103/2*m
  DC.W   105/2*m
  DC.W   106/2*m
  DC.W   108/2*m
  DC.W   110/2*m
  DC.W   112/2*m
  DC.W   113/2*m
  DC.W   114/2*m
  DC.W   115/2*m
  DC.W   116/2*m
  DC.W   117/2*m
  DC.W   118/2*m
  DC.W   119/2*m
  DC.W   119/2*m
  DC.W   120/2*m
  DC.W   120/2*m
  DC.W   120/2*m
  DC.W   120/2*m
  DC.W   120/2*m
  DC.W   120/2*m
  DC.W   119/2*m
  DC.W   119/2*m
  DC.W   118/2*m
  DC.W   118/2*m
  DC.W   117/2*m
  DC.W   116/2*m
  DC.W   115/2*m
  DC.W   114/2*m
  DC.W   112/2*m
  DC.W   111/2*m
  DC.W   110/2*m
  DC.W   108/2*m
  DC.W   106/2*m
  DC.W   105/2*m
  DC.W   103/2*m
  DC.W   101/2*m
  DC.W   99/2*m
  DC.W   97/2*m
  DC.W   94/2*m
  DC.W   92/2*m
  DC.W   90/2*m
  DC.W   88/2*m
  DC.W   85/2*m
  DC.W   83/2*m
  DC.W   80/2*m
  DC.W   78/2*m
  DC.W   75/2*m
  DC.W   72/2*m
  DC.W   70/2*m
  DC.W   67/2*m
  DC.W   64/2*m
  DC.W   62/2*m
  DC.W   59/2*m
  DC.W   56/2*m
  DC.W   54/2*m
  DC.W   51/2*m
  DC.W   48/2*m
  DC.W   46/2*m
  DC.W   43/2*m
  DC.W   40/2*m
  DC.W   38/2*m
  DC.W   35/2*m
  DC.W   33/2*m
  DC.W   31/2*m
  DC.W   28/2*m
  DC.W   26/2*m
  DC.W   24/2*m
  DC.W   22/2*m
  DC.W   20/2*m
  DC.W   18/2*m
  DC.W   16/2*m
  DC.W   14/2*m
  DC.W   12/2*m
  DC.W   11/2*m
  DC.W   9/2*m
  DC.W   8/2*m
  DC.W   7/2*m
  DC.W   5/2*m
  DC.W   4/2*m
  DC.W   3/2*m
  DC.W   3/2*m
  DC.W   2/2*m
  DC.W   1/2*m
sinend2:
  DC.W   1/2*m
	dc.w	9999,9999,9999,9999,9999,9999

PLAY_MUSIC:
 bra PLAY

END_MUSIC:
 clr.w onoff
 clr.l $dff0a6
 clr.l $dff0b6
 clr.l $dff0c6
 clr.l $dff0d6
 move.w #$000f,$dff096
 bclr #1,$bfe001
 rts

INIT_MUSIC:
 move.w #1,onoff
 bset #1,$bfe001
 lea	module,a0
 lea 100(a0),a1
 move.l a1,SEQpoint
 move.l a0,a1
 add.l 8(a0),a1
 move.l a1,PATpoint
 move.l a0,a1
 add.l 16(a0),a1
 move.l a1,FRQpoint
 move.l a0,a1
 add.l 24(a0),a1
 move.l a1,VOLpoint
 move.l 4(a0),d0
 divu #13,d0

 lea 40(a0),a1
 lea SOUNDINFO+4(pc),a2
 moveq #10-1,d1
initloop:
 move.w (a1)+,(a2)+
 move.l (a1)+,(a2)+
 addq.w #4,a2
 dbf d1,initloop
 moveq #0,d2
 move.l a0,d1
 add.l 32(a0),d1
 sub.l #WAVEFORMS,d1
 lea SOUNDINFO(pc),a0
 move.l d1,(a0)+
 moveq #9-1,d3
initloop1:
 move.w (a0),d2
 add.l d2,d1
 add.l d2,d1
 addq.w #6,a0
 move.l d1,(a0)+
 dbf d3,initloop1

 move.l SEQpoint(pc),a0
 moveq #0,d2
 move.b 12(a0),d2		;Get replay speed
 bne.s speedok
 move.b #3,d2			;Set default speed
speedok:
 move.w d2,respcnt		;Init repspeed counter
 move.w d2,repspd
INIT2:
 clr.w audtemp
 move.w #$000f,$dff096		;Disable audio DMA
 move.w #$0780,$dff09a		;Disable audio IRQ
 moveq #0,d7
 mulu #13,d0
 moveq #4-1,d6			;Number of soundchannels-1
 lea V1data(pc),a0		;Point to 1st voice data area
 lea silent(pc),a1
 lea o4a0c8(pc),a2
initloop2:
 move.l a1,10(a0)
 move.l a1,18(a0)
 clr.l 14(a0)
 clr.b 45(a0)
 clr.b 47(a0)
 clr.w 8(a0)
 clr.l 48(a0)
 move.b #$01,23(a0)
 move.b #$01,24(a0)
 clr.b 25(a0)
 clr.l 26(a0)
 clr.w 30(a0)
 moveq #$00,d3
 move.w (a2)+,d1
 move.w (a2)+,d3
 divu #$0003,d3
 move.b d3,32(a0)
 mulu #$0003,d3
 andi.l #$00ff,d3
 andi.l #$00ff,d1
 addi.l #$dff0a0,d1
 move.l d1,a6
 move.l #$0000,(a6)
 move.w #$0100,4(a6)
 move.w #$0000,6(a6)
 move.w #$0000,8(a6)
 move.l d1,60(a0)
 clr.w 64(a0)
 move.l SEQpoint(pc),(a0)
 move.l SEQpoint(pc),52(a0)
 add.l d0,52(a0)
 add.l d3,52(a0)
 add.l d7,(a0)
 add.l d3,(a0)
 move.w #$000d,6(a0)
 move.l (a0),a3
 move.b (a3),d1
 andi.l #$00ff,d1
 lsl.w #6,d1
 move.l PATpoint(pc),a4
 adda.w d1,a4
 move.l a4,34(a0)
 clr.l 38(a0)
 move.b #$01,33(a0)
 move.b #$02,42(a0)
 move.b 1(a3),44(a0)
 move.b 2(a3),22(a0)
 clr.b 43(a0)
 clr.b 45(a0)
 clr.w 56(a0)
 adda.w #$004a,a0	;Point to next voice's data area
 dbf d6,initloop2
rts


PLAY:
 lea pervol(pc),a6
 tst.w onoff
 bne.s music_on
 rts
music_on:
 subq.w #1,respcnt		;Decrease replayspeed counter
 bne.s nonewnote
 move.w repspd(pc),respcnt	;Restore replayspeed counter
 lea V1data(pc),a0		;Point to voice1 data area
 bsr new_note
 move.b tempreg,d5
; and.b #%00111111,d5
 move.b d5,vs1
 lea V2data(pc),a0		;Point to voice2 data area
 bsr new_note
 move.b tempreg,d5
; and.b #%00111111,d5
 move.b d5,vs2
 lea V3data(pc),a0		;Point to voice3 data area
 bsr new_note
 move.b tempreg,d5
; and.b #%00111111,d5
 move.b d5,vs3
 lea V4data(pc),a0		;Point to voice4 data area
 bsr new_note
 move.b tempreg,d5
; and.b #%00111111,d5
 move.b d5,vs4
nonewnote:
 clr.w audtemp
 lea V1data(pc),a0
 bsr effects
 move.w d0,(a6)+
 move.w d1,(a6)+
 lea V2data(pc),a0
 bsr effects
 move.w d0,(a6)+
 move.w d1,(a6)+
 lea V3data(pc),a0
 bsr effects
 move.w d0,(a6)+
 move.w d1,(a6)+
 lea V4data(pc),a0
 bsr effects
 move.w d0,(a6)+
 move.w d1,(a6)+
 lea pervol(pc),a6
 move.w audtemp(pc),d0
 ori.w #$8000,d0			;Set/clr bit = 1
 move.w d0,-(a7)
 moveq #0,d1
 move.l start1(pc),d2		;Get samplepointers
 move.w offset1(pc),d1		;Get offset
 add.l d1,d2			;Add offset
 move.l start2(pc),d3
 move.w offset2(pc),d1
 add.l d1,d3
 move.l start3(pc),d4
 move.w offset3(pc),d1
 add.l d1,d4
 move.l start4(pc),d5
 move.w offset4(pc),d1
 add.l d1,d5
 move.w ssize1(pc),d0		;Get sound lengths
 move.w ssize2(pc),d1
 move.w ssize3(pc),d6
 move.w ssize4(pc),d7
 move.w (a7)+,$dff096		;Enable audio DMA
chan1:
 lea V1data(pc),a0
 tst.w 72(a0)
 beq.w chan2
 subq.w #1,72(a0)
 cmpi.w #1,72(a0)
 bne.s chan2
 clr.w 72(a0)
 move.l d2,$dff0a0		;Set soundstart
 move.w d0,$dff0a4		;Set soundlength
chan2:
 lea V2data(pc),a0
 tst.w 72(a0)
 beq.s chan3
 subq.w #1,72(a0)
 cmpi.w #1,72(a0)
 bne.s chan3
 clr.w 72(a0)
 move.l d3,$dff0b0
 move.w d1,$dff0b4
chan3:
 lea V3data(pc),a0
 tst.w 72(a0)
 beq.s chan4
 subq.w #1,72(a0)
 cmpi.w #1,72(a0)
 bne.s chan4
 clr.w 72(a0)
 move.l d4,$dff0c0
 move.w d6,$dff0c4
chan4:
 lea V4data(pc),a0
 tst.w 72(a0)
 beq.s setpervol
 subq.w #1,72(a0)
 cmpi.w #1,72(a0)
 bne.s setpervol
 clr.w 72(a0)
 move.l d5,$dff0d0
 move.w d7,$dff0d4
setpervol:
 lea $dff0a6,a5
 move.w (a6)+,(a5)	;Set period
 move.w (a6)+,2(a5)	;Set volume
 move.w (a6)+,16(a5)
 move.w (a6)+,18(a5)
 move.w (a6)+,32(a5)
 move.w (a6)+,34(a5)
 move.w (a6)+,48(a5)
 move.w (a6)+,50(a5)
 rts

NEW_NOTE:
 moveq #0,d5
 move.l 34(a0),a1
 adda.w 40(a0),a1
 cmp.w #64,40(a0)
 bne.w samepat
 move.l (a0),a2
 adda.w 6(a0),a2		;Point to next sequence row
 cmpa.l 52(a0),a2	;Is it the end?
 bne.s notend
 move.w d5,6(a0)		;yes!
 move.l (a0),a2		;Point to first sequence
notend:
 moveq #0,d1
 addq.b #1,spdtemp
 cmpi.b #4,spdtemp
 bne.s nonewspd
 move.b d5,spdtemp
 move.b -1(a1),d1	;Get new replay speed
 beq.s nonewspd
 move.w d1,respcnt	;store in counter
 move.w d1,repspd
nonewspd:
 move.b (a2),d1		;Pattern to play
 move.b 1(a2),44(a0)	;Transpose value
 move.b 2(a2),22(a0)	;Soundtranspose value

 move.w d5,40(a0)
 lsl.w #6,d1
 add.l PATpoint(pc),d1	;Get pattern pointer
 move.l d1,34(a0)
 addi.w #$000d,6(a0)
 move.l d1,a1
samepat:
 move.b 1(a1),d1		;Get info byte
 move.b (a1)+,d0		;Get note
 move.b d0,tempreg
 bne.s ww1
 andi.w #%11000000,d1
 beq.s noport
 bra.s ww11
ww1:
 move.w d5,56(a0)
ww11:
 move.b d5,47(a0)
 move.b (a1),31(a0)

		;31(a0) = PORTAMENTO/INSTR. info
			;Bit 7 = portamento on
			;Bit 6 = portamento off
			;Bit 5-0 = instrument number
		;47(a0) = portamento value
			;Bit 7-5 = always zero
			;Bit 4 = up/down
			;Bit 3-0 = value
t_porton:
 btst #7,d1
 beq.s noport
 move.b 2(a1),47(a0)	
noport:
 andi.w #$007f,d0
 beq.w nextnote
 move.b d0,8(a0)
 move.b (a1),9(a0)
 move.b 32(a0),d2
 moveq #0,d3
 bset d2,d3
 or.w d3,audtemp
 move.w d3,$dff096
 move.b (a1),d1
 andi.w #$003f,d1	;Max 64 instruments
 add.b 22(a0),d1
 move.l VOLpoint(pc),a2
 lsl.w #6,d1
 adda.w d1,a2
 move.w d5,16(a0)
 move.b (a2),23(a0)
 move.b (a2)+,24(a0)
 move.b (a2)+,d1
 andi.w #$00ff,d1
 move.b (a2)+,27(a0)
 move.b #$40,46(a0)
 move.b (a2)+,d0
 move.b d0,28(a0)
 move.b d0,29(a0)
 move.b (a2)+,30(a0)
 move.l a2,10(a0)
 move.l FRQpoint(pc),a2
 lsl.w #6,d1
 adda.w d1,a2
 move.l a2,18(a0)
 move.w d5,50(a0)
 move.b d5,26(a0)
 move.b d5,25(a0)
nextnote:
 addq.w #2,40(a0)
 rts

EFFECTS:
 moveq #0,d7
testsustain:
 tst.b 26(a0)		;Is sustain counter = 0
 beq.s sustzero
 subq.b #1,26(a0)	;if no, decrease counter
 bra VOLUfx
sustzero:		;Next part of effect sequence
 move.l 18(a0),a1	;can be executed now.
 adda.w 50(a0),a1
testeffects:
 cmpi.b #$e1,(a1)	;E1 = end of FREQseq sequence
 beq.w VOLUfx
 cmpi.b #$e0,(a1)	;E0 = loop to other part of sequence
 bne.s testnewsound
 move.b 1(a1),d0		;loop to start of sequence + 1(a1)
 andi.w #$003f,d0
 move.w d0,50(a0)
 move.l 18(a0),a1
 adda.w d0,a1
testnewsound:
 cmpi.b #$e2,(a1)	;E2 = set waveform
 bne.s o49c64
 moveq #0,d0
 moveq #0,d1
 move.b 32(a0),d1
 bset d1,d0
 or.w d0,audtemp
 move.w d0,$dff096
 move.b 1(a1),d0
 andi.w #$00ff,d0
 lea SOUNDINFO(pc),a4
 add.w d0,d0
 move.w d0,d1
 add.w d1,d1
 add.w d1,d1
 add.w d1,d0
 adda.w d0,a4
 move.l 60(a0),a3
 move.l (a4),d1
 add.l #WAVEFORMS,d1
 move.l d1,(a3)
 move.l d1,68(a0)
 move.w 4(a4),4(a3)
 move.l 6(a4),64(a0)
 swap d1
 move.w #$0003,72(a0)
 tst.w d1
 bne.s o49c52
 move.w #$0002,72(a0)
o49c52:
 clr.w 16(a0)
 move.b #$01,23(a0)
 addq.w #2,50(a0)
 bra o49d02
o49c64:
 cmpi.b #$e4,(a1)
 bne.s testpatjmp
 move.b 1(a1),d0
 andi.w #$00ff,d0
 lea SOUNDINFO(pc),a4
 add.w d0,d0
 move.w d0,d1
 add.w d1,d1
 add.w d1,d1
 add.w d1,d0
 adda.w d0,a4
 move.l 60(a0),a3
 move.l (a4),d1
 add.l #WAVEFORMS,d1
 move.l d1,(a3)
 move.l d1,68(a0)
 move.w 4(a4),4(a3)
 move.l 6(a4),64(a0)

 swap d1
 move.w #$0003,72(a0)
 tst.w d1
 bne.s o49cae
 move.w #$0002,72(a0)
o49cae:
 addq.w #2,50(a0)
 bra.s o49d02
testpatjmp:
 cmpi.b #$e7,(a1)
 bne.s testnewsustain
 move.b 1(a1),d0
 andi.w #$00ff,d0
 lsl.w #6,d0
 move.l FRQpoint(pc),a1
 adda.w d0,a1
 move.l a1,18(a0)
 move.w d7,50(a0)
 bra testeffects
testnewsustain:
 cmpi.b #$e8,(a1)	;E8 = set sustain time
 bne.s o49cea
 move.b 1(a1),26(a0)
 addq.w #2,50(a0)
 bra testsustain
o49cea:
 cmpi.b #$e3,(a1)
 bne.s o49d02
 addq.w #3,50(a0)
 move.b 1(a1),27(a0)
 move.b 2(a1),28(a0)
o49d02:
 move.l 18(a0),a1
 adda.w 50(a0),a1
 move.b (a1),43(a0)
 addq.w #1,50(a0)
VOLUfx:
 tst.b 25(a0)
 beq.s o49d1e
 subq.b #1,25(a0)
 bra.s o49d70
o49d1e:
 subq.b #1,23(a0)
 bne.s o49d70
 move.b 24(a0),23(a0)
o49d2a:
 move.l 10(a0),a1
 adda.w 16(a0),a1
 move.b (a1),d0
 cmpi.b #$e8,d0
 bne.s o49d4a
 addq.w #2,16(a0)
 move.b 1(a1),25(a0)
 bra.s VOLUfx
o49d4a:
 cmpi.b #$e1,d0
 beq.s o49d70
 cmpi.b #$e0,d0
 bne.s o49d68
 move.b 1(a1),d0
 andi.l #$003f,d0
 subq.b #5,d0
 move.w d0,16(a0)
 bra.s o49d2a
o49d68:
 move.b (a1),45(a0)
 addq.w #1,16(a0)
o49d70:
 move.b 43(a0),d0
 bmi.s o49d7e
 add.b 8(a0),d0
 add.b 44(a0),d0
o49d7e:
 andi.w #$007f,d0
 lea PERIODS(pc),a1
 add.w d0,d0
 move.w d0,d1
 adda.w d0,a1
 move.w (a1),d0
 move.b 46(a0),d7
 tst.b 30(a0)
 beq.s o49d9e
 subq.b #1,30(a0)

 bra.s o49df4
o49d9e:
 move.b d1,d5
 move.b 28(a0),d4
 add.b d4,d4
 move.b 29(a0),d1
 tst.b d7
 bpl.s o49db4
 btst #0,d7
 bne.s o49dda
o49db4:
 btst #5,d7
 bne.s o49dc8
 sub.b 27(a0),d1
 bcc.s o49dd6
 bset #5,d7
 moveq #0,d1
 bra.s o49dd6
o49dc8:
 add.b 27(a0),d1
 cmp.b d4,d1
 bcs.s o49dd6
 bclr #5,d7
 move.b d4,d1
o49dd6:
 move.b d1,29(a0)
o49dda:
 lsr.b #1,d4
 sub.b d4,d1
 bcc.s o49de4
 subi.w #$0100,d1
o49de4:
 addi.b #$a0,d5
 bcs.s o49df2
o49dea:
 add.w d1,d1
 addi.b #$18,d5
 bcc.s o49dea
o49df2:
 add.w d1,d0
o49df4:
 eori.b #$01,d7
 move.b d7,46(a0)

; DO THE PORTAMENTO THING
 moveq #0,d1
 move.b 47(a0),d1	;get portavalue
 beq.s a56d0		;0=no portamento
 cmpi.b #$1f,d1
 bls.s portaup
portadown: 
 andi.w #$1f,d1
 neg.w d1
portaup:
 sub.w d1,56(a0)
a56d0:
 add.w 56(a0),d0
o49e3e:
 cmpi.w #$0070,d0
 bhi.s nn1
 move.w #$0071,d0
nn1:
 cmpi.w #$06b0,d0
 bls.s nn2
 move.w #$06b0,d0
nn2:
 moveq #0,d1
 move.b 45(a0),d1
 rts



pervol:	 dcb.b 16,0	;Periods & Volumes temp. store
respcnt: dc.w 0		;Replay speed counter 
repspd:  dc.w 0		;Replay speed counter temp
onoff:   dc.w 0		;Music on/off flag.
firseq:	 dc.w 0		;First sequence
lasseq:	 dc.w 0		;Last sequence
audtemp: dc.w 0
spdtemp: dc.w 0

V1data:  dcb.b 64,0	;Voice 1 data area
offset1: dcb.b 02,0	;Is added to start of sound
ssize1:  dcb.b 02,0	;Length of sound
start1:  dcb.b 06,0	;Start of sound

V2data:  dcb.b 64,0	;Voice 2 data area
offset2: dcb.b 02,0
ssize2:  dcb.b 02,0
start2:  dcb.b 06,0

V3data:  dcb.b 64,0	;Voice 3 data area
offset3: dcb.b 02,0
ssize3:  dcb.b 02,0
start3:  dcb.b 06,0

V4data:  dcb.b 64,0	;Voice 4 data area
offset4: dcb.b 02,0
ssize4:  dcb.b 02,0
start4:  dcb.b 06,0

o4a0c8: dc.l $00000000,$00100003,$00200006,$00300009
SEQpoint: dc.l 0
PATpoint: dc.l 0
FRQpoint: dc.l 0
VOLpoint: dc.l 0


even
SILENT: dc.w $0100,$0000,$0000,$00e1

PERIODS:dc.w $06b0,$0650,$05f4,$05a0,$054c,$0500,$04b8,$0474
	dc.w $0434,$03f8,$03c0,$038a,$0358,$0328,$02fa,$02d0
	dc.w $02a6,$0280,$025c,$023a,$021a,$01fc,$01e0,$01c5
	dc.w $01ac,$0194,$017d,$0168,$0153,$0140,$012e,$011d
	dc.w $010d,$00fe,$00f0,$00e2,$00d6,$00ca,$00be,$00b4
	dc.w $00aa,$00a0,$0097,$008f,$0087,$007f,$0078,$0071
	dc.w $0071,$0071,$0071,$0071,$0071,$0071,$0071,$0071
	dc.w $0071,$0071,$0071,$0071,$0d60,$0ca0,$0be8,$0b40
	dc.w $0a98,$0a00,$0970,$08e8,$0868,$07f0,$0780,$0714
	dc.w $1ac0,$1940,$17d0,$1680,$1530,$1400,$12e0,$11d0
	dc.w $10d0,$0fe0,$0f00,$0e28

SOUNDINFO:
;Offset.l , Sound-length.w , Start-offset.w , Repeat-length.w 

;Reserved for samples
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
	dc.w $0000,$0000,$0000,$0000,$0001 
;Reserved for synth sounds
	dc.w $0000,$0000,$0010,$0000,$0010
	dc.w $0000,$0020,$0010,$0000,$0010
	dc.w $0000,$0040,$0010,$0000,$0010
	dc.w $0000,$0060,$0010,$0000,$0010
	dc.w $0000,$0080,$0010,$0000,$0010
	dc.w $0000,$00a0,$0010,$0000,$0010
	dc.w $0000,$00c0,$0010,$0000,$0010
	dc.w $0000,$00e0,$0010,$0000,$0010
	dc.w $0000,$0100,$0010,$0000,$0010
	dc.w $0000,$0120,$0010,$0000,$0010
	dc.w $0000,$0140,$0010,$0000,$0010
	dc.w $0000,$0160,$0010,$0000,$0010
	dc.w $0000,$0180,$0010,$0000,$0010 
	dc.w $0000,$01a0,$0010,$0000,$0010 
	dc.w $0000,$01c0,$0010,$0000,$0010 
	dc.w $0000,$01e0,$0010,$0000,$0010 
	dc.w $0000,$0200,$0010,$0000,$0010 
	dc.w $0000,$0220,$0010,$0000,$0010 
	dc.w $0000,$0240,$0010,$0000,$0010 
	dc.w $0000,$0260,$0010,$0000,$0010 
	dc.w $0000,$0280,$0010,$0000,$0010 
	dc.w $0000,$02a0,$0010,$0000,$0010 
	dc.w $0000,$02c0,$0010,$0000,$0010 
	dc.w $0000,$02e0,$0010,$0000,$0010 
	dc.w $0000,$0300,$0010,$0000,$0010 
	dc.w $0000,$0320,$0010,$0000,$0010 
	dc.w $0000,$0340,$0010,$0000,$0010 
	dc.w $0000,$0360,$0010,$0000,$0010 
	dc.w $0000,$0380,$0010,$0000,$0010 
	dc.w $0000,$03a0,$0010,$0000,$0010 
	dc.w $0000,$03c0,$0010,$0000,$0010 
	dc.w $0000,$03e0,$0010,$0000,$0010 
	dc.w $0000,$0400,$0008,$0000,$0008 
	dc.w $0000,$0410,$0008,$0000,$0008 
	dc.w $0000,$0420,$0008,$0000,$0008 
	dc.w $0000,$0430,$0008,$0000,$0008 
	dc.w $0000,$0440,$0008,$0000,$0008
	dc.w $0000,$0450,$0008,$0000,$0008
	dc.w $0000,$0460,$0008,$0000,$0008
	dc.w $0000,$0470,$0008,$0000,$0008
	dc.w $0000,$0480,$0010,$0000,$0010
	dc.w $0000,$04a0,$0008,$0000,$0008
	dc.w $0000,$04b0,$0010,$0000,$0010
	dc.w $0000,$04d0,$0010,$0000,$0010
	dc.w $0000,$04f0,$0008,$0000,$0008
	dc.w $0000,$0500,$0008,$0000,$0008
	dc.w $0000,$0510,$0018,$0000,$0018
 

WAVEFORMS:
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $3f37,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c037,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b027,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a017,$0f07,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$0f07,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9007,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9088,$ff07,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9088,$8007,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9088,$8088,$0f17,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9017,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9098,$1f27,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9098,$a027,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9098,$a0a8,$2f37
 dc.w $c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
 dc.w $c0b8,$b0a8,$a098,$9088,$8088,$9098,$a0a8,$b037
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$8181,$8181,$817f,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$8181,$8181,$8181,$7f7f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$8181,$8181,$8181,$817f,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$7f7f,$7f7f
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
 dc.w $8181,$8181,$8181,$8181,$8181,$8181,$817f,$7f7f
 dc.w $8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080
 dc.w $8080,$8080,$8080,$8080,$8080,$8080,$8080,$7f7f
 dc.w $8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080
 dc.w $8080,$8080,$8080,$8080,$8080,$8080,$8080,$807f
 dc.w $8080,$8080,$8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8080,$8080,$8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8080,$8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8080,$8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
 dc.w $8080,$9098,$a0a8,$b0b8,$c0c8,$d0d8,$e0e8,$f0f8
 dc.w $0008,$1018,$2028,$3038,$4048,$5058,$6068,$707f
 dc.w $8080,$a0b0,$c0d0,$e0f0,$0010,$2030,$4050,$6070
 dc.w $4545,$797d,$7a77,$7066,$6158,$534d,$2c20,$1812
 dc.w $04db,$d3cd,$c6bc,$b5ae,$a8a3,$9d99,$938e,$8b8a
 dc.w $4545,$797d,$7a77,$7066,$5b4b,$4337,$2c20,$1812
 dc.w $04f8,$e8db,$cfc6,$beb0,$a8a4,$9e9a,$9594,$8d83
 dc.w $0000,$4060,$7f60,$4020,$00e0,$c0a0,$80a0,$c0e0
 dc.w $0000,$4060,$7f60,$4020,$00e0,$c0a0,$80a0,$c0e0
 dc.w $8080,$9098,$a0a8,$b0b8,$c0c8,$d0d8,$e0e8,$f0f8
 dc.w $0008,$1018,$2028,$3038,$4048,$5058,$6068,$707f
 dc.w $8080,$a0b0,$c0d0,$e0f0,$0010,$2030,$4050,$6070

module:	incbin "dex4"

logo:	incbin	"logo.b"

vs1:	dc.b	0
vs2:	dc.b	0
vs3:	dc.b	0
vs4:	dc.b	0
tempreg:dc.b	0

